

'-----------------------------------------------------------------------------------
' Control
'-----------------------------------------------------------------------------------
Type Control Extends Object 	
  	Public:
  	Declare Constructor
   Declare Destructor 
  	Declare Property Left() As Integer							' Get  Left
   Declare Property Left( ByVal value As Integer )			' Set  Left
  	Declare Property Top() As Integer							' Get  Top
   Declare Property Top( ByVal value As Integer )			' Set  Top
	Declare Property Width() As Integer							' Get  Width
   Declare Property Width( ByVal value As Integer )		' Set  Width
  	Declare Property Height() As Integer						' Get  Height
   Declare Property Height( ByVal value As Integer )		' Set  Height
   Declare Property ClientHeight() As Integer				' Get  ClientHeight  
   Declare Property ClientWidth() As Integer					' Get  ClientWidth 
   Declare Property Caption as string							' Get  Caption
   Declare Property Caption(value as string)					' Set  Caption
   Declare Property Font() As HFONT								' Get  FontHandle
   Declare Property Style() As UInteger						' Get  Style
   Declare Property Style(ByVal value As UInteger)			' Set  Style
  	Declare Property ExStyle() As UInteger						' Get  ExStyle
  	Declare Property ExStyle(ByVal value As UInteger)		' Set  ExStyle
  	Declare Property Visible as Integer							' Get  Visible
   Declare Property Visible( ByVal value as Integer)		' Set  Visible	
   Declare Property Enabled as Integer							' Get  Enabled
   Declare Property Enabled( ByVal value as Integer)		' Set  Enabled
   Declare VIRTUAL Property TextColor() As UInteger					' Get  TextColor
   Declare VIRTUAL Property TextColor( ByVal value As UInteger )	' Set  TextColor   
   Declare VIRTUAL Property Color() As UInteger							' Get  HintergrundColor
   Declare VIRTUAL Property Color( ByVal value As UInteger )		' Set  HintergrundColor
   Declare Property Handle() As HWND							' Get  Handle Control
   Declare Property Handle( ByVal value As HWND )			' Set  Handle Control
   Declare Property Parent() As HWND							' Get  Handle
   Declare Property Parent( ByVal value As HWND )			' Set  Handle
   Declare Property CtHandle() As HWND							' Get Container Handle
	Declare Property CtHandle( ByVal value As HWND )		' Set Container Handle
	Declare Property Tip( ByVal value As String )			' Set  ToolTip
   ' Methods
   Declare Sub Invalidate
   Declare Sub Focus
	Declare Sub Repaint
	Declare Sub setFont(Face As String,ByVal size As Integer,ByVal bold As Integer,ByVal italic As Integer,ByVal underlin As Integer)
	Declare VIRTUAL Function CtrlMsgFunc(hWnd As HWND,uMsg as UINT,wParam as wParam,lParam as lParam) as LRESULT	
   Declare Static Function DispMsg(hWnd As HWND,uMsg as UINT,wParam as wParam,lParam as lParam) as LRESULT
   
   Private:
   Declare Sub DisplayToolTip
   As HWND		b_hwndTT
   As String	b_tooltip		= "" 
	As Short		b_Left			= 0
	As Short  	b_Top				= 0
   As Short 	b_Width 	 		= 0
  	As Short 	b_Height   		= 0
  	As HWND    	b_Handle   		= 0
  	As HWND    	b_Parent   		= 0
  	As HWND    	b_Cthandle 		= 0
  	As String 	b_Caption   	= ""
  	As UInteger	b_ExStyle		= 0
	As UInteger	b_Style 			= 0
	As Integer  b_Visible 		= SW_SHOWNORMAL
	As Integer  b_Enabled		= TRUE
	As UInteger	b_TextColor		= 0								' Vordergrund(Text) Schwarz
	As UInteger	b_Color			= &HDCDCDC						' Hintergrund hellgrau
	As HFONT		b_hFont	
	
End Type

Destructor Control
	
		If this.b_hFont Then
			DeleteObject(this.b_hFont)
			this.b_hFont = 0
		EndIf	
	
End Destructor
Constructor Control	
	
	Dim wcls as WNDCLASS     
   Dim As ZString * 128 szClass
    
   szClass = "FB_CONTROL"
   ' Class fr die Conainer der Controls 
   If GetClassInfo(GetModuleHandle(0),@szClass,@wcls) = 0 Then               
	    with wcls
	    	.style         = CS_HREDRAW or CS_VREDRAW
	    	.lpfnWndProc   = @DispMsg
	    	.cbClsExtra    = 0
	    	.cbWndExtra    = 0
	    	.hInstance     = GetModuleHandle(0)
	    	.hIcon         = NULL
	    	.hCursor       = LoadCursor(NULL, IDC_ARROW )
	    	.hbrBackground = GetStockObject(WHITE_BRUSH)
	    	.lpszMenuName  = NULL
	    	.lpszClassName = @szClass
	    end with
	          
	    if( RegisterClass( @wcls ) = FALSE ) then
	       MessageBox( null, "Fehler - FB_CONTROL Class ist nicht registriert", "Error", MB_ICONERROR )
	    end if
   End If 
	
  	this.b_Handle 		= 0
  	this.b_Cthandle	= 0
  	this.ExStyle 		= 0	
	this.Style 	 		= WS_VISIBLE Or WS_CHILD
	this.b_Visible 	= SW_SHOWNORMAL
	this.b_Enabled		= TRUE
	this.b_TextColor 	= 0							
	this.b_Color		= &HDCDCDC	
	this.b_hFont		= GetStockObject(SYSTEM_FONT)	

end Constructor

Property Control.Font() As HFONT
	Return this.b_hFont
End Property
Property Control.Left() As Integer
  Return this.b_Left 
End Property
Property Control.Left( ByVal value As Integer )
	this.b_Left = value
	If this.b_Cthandle Then
		MoveWindow(this.b_Cthandle,this.b_Left,this.b_Top,this.b_Width,this.b_Height ,TRUE)	
	Else	
  		MoveWindow(this.b_Handle,this.b_Left,this.b_Top,this.b_Width,this.b_Height ,TRUE)	
	End If	
End Property
Property Control.Top() As Integer
  Return this.b_Top
End Property
Property Control.Top( ByVal value As Integer )
	this.b_Top = value
	If this.b_Cthandle Then
		MoveWindow(this.b_Cthandle,this.b_Left,this.b_Top,this.b_Width,this.b_Height ,TRUE)	
	Else	
  		MoveWindow(this.b_Handle,this.b_Left,this.b_Top,this.b_Width,this.b_Height ,TRUE)	
	End If	
End Property

Property Control.Width() As Integer
  Return this.b_Width 
End Property

Property Control.Width( ByVal value As Integer )
  	this.b_Width = value
	If this.b_Cthandle Then
		MoveWindow(this.b_Cthandle,this.b_Left,this.b_Top,this.b_Width,this.b_Height ,TRUE)	
	Else	
  		MoveWindow(this.b_Handle,this.b_Left,this.b_Top,this.b_Width,this.b_Height ,TRUE)	
	End If	
End Property

Property Control.Height() As Integer
  Return this.b_Height
End Property

Property Control.Height( ByVal value As Integer )
	this.b_Height = value
	If this.b_Cthandle Then
		MoveWindow(this.b_Cthandle,this.b_Left,this.b_Top,this.b_Width,this.b_Height ,TRUE)	
	Else	
  		MoveWindow(this.b_Handle,this.b_Left,this.b_Top,this.b_Width,this.b_Height ,TRUE)	
	End If	 
End Property

Property Control.ClientHeight() As Integer
	If this.b_Handle Then
		Dim rc As RECT
		GetClientRect(this.b_Handle,@rc)
		Return rc.bottom
	EndIf
End Property

Property Control.ClientWidth() As Integer
  	If this.b_Handle Then
		Dim rc As RECT
		GetClientRect(this.b_Handle,@rc)
		Return rc.right
	EndIf
End Property

Property Control.Handle() As HWND							' Get Handle
  Return this.b_Handle
End Property

Property Control.Handle(ByVal Value As HWND)				' Set Handle
  this.b_Handle = Value
End Property
Property Control.CtHandle() As HWND							' Get Container-Handle
  Return this.b_Cthandle
End Property
Property Control.CtHandle(ByVal Value As HWND)			' Set Container-Handle
  this.b_Cthandle = Value
End Property
Property Control.Parent() As HWND							' Get Handle
  Return this.b_Parent
End Property
Property Control.Parent(ByVal Value As HWND)				' Set Handle
  this.b_Parent = Value
End Property
Property Control.Caption as string							' Get Caption
   Return this.b_Caption
End Property
Property Control.Caption(value as string)    			' Set Caption
	If this.b_Handle Then
   	this.b_Caption = value 
    	SetWindowText(b_Handle,value) 
    	Repaint
	End If 	
end Property
Property Control.Style() As UInteger						' Get  Style
	 Return this.b_Style
end Property
Property Control.Style(ByVal value As UInteger)			' Set  Style
		this.b_Style = value
End Property
Property Control.ExStyle() As UInteger						' Get  ExStyle
	Return this.b_ExStyle
end Property
Property Control.ExStyle(ByVal value As UInteger)		' Set  ExStyle
		this.b_ExStyle = value	
end Property
Property Control.Enabled as Integer
	Return this.b_Enabled
End Property
Property Control.Enabled(ByVal value as Integer) 			' value = True : Enabled
	 this.b_Enabled = IIf(value,TRUE,FALSE)
	 If this.b_Handle Then
     EnableWindow(this.b_Handle,this.b_Enabled)
	 End If
End Property
Property Control.Visible as Integer
	Return this.b_Visible
End Property
Property Control.Visible(ByVal value as Integer) 			' value = 0 : SW_HIDE ; 1 : SW_SHOW		
	this.b_Visible = value	
	If this.b_Cthandle Then
		ShowWindow(this.b_Cthandle,IIf(value,SW_SHOW,SW_HIDE))
	Else
  		ShowWindow(this.b_Handle,IIf(value,SW_SHOW,SW_HIDE))	     
	End If
End Property
Property Control.TextColor() As UInteger						' Get  TextColor
	Return this.b_TextColor
end Property
Property Control.TextColor( ByVal value As UInteger )  	' Set  TextColor	
		this.b_TextColor = value
		Repaint
End Property
Property Control.Color() As UInteger							' Get  HintergrundColor
	Return this.b_Color
End Property
Property Control.Color( ByVal value As UInteger )			' Set  Hintergrund Color 	
		this.b_Color = value
		Repaint
end Property
Property Control.Tip( ByVal value As String )
	this.b_tooltip = value	
	If  (Len(this.b_tooltip) > 0) And (this.Handle > 0) Then
		DisplayToolTip 
	EndIf
End Property
 
Sub Control.DisplayToolTip 
	
	If InitCommon = 0 Then 
		InitCommonControls
		InitCommon = 1
	EndIf
	
	Dim AS TOOLINFO ti
	Dim szTip As ZString * 64
	
	If Len(this.b_tooltip) = 0 Then Exit Sub
	szTip = this.b_tooltip
	
	this.b_hwndTT = CreateWindow(TOOLTIPS_CLASS,  NULL, TTS_ALWAYSTIP, _ 
        CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, _
        NULL,  NULL, GetModuleHandle(0), NULL) 
   
   If  this.b_hwndTT Then    
	   ti.cbSize=sizeof(TOOLINFO)
	   ti.uFlags=TTF_SUBCLASS
	   If this.Handle Then
	   	ti.hwnd=this.Handle
	   End If	
	   ti.hinst=GetModuleHandle(0)
	   ti.lpszText=@szTip
	   GetClientRect(this.Handle, @ti.rect)
	   SendMessage(this.b_hwndTT, TTM_ADDTOOL, 0, CAST(LPARAM, @ti))
   End If 	
End Sub

Function Control.CtrlMsgFunc(hWnd As HWND,uMsg as UINT,wParam as wParam,lParam as lParam) as LRESULT
	
	Function = DefWindowProc(hWnd ,uMsg ,wParam , lParam )
	
End Function

Function Control.DispMsg(hWnd As HWND,uMsg as UINT,wParam as wParam,lParam as lParam) as LRESULT

	Dim obj As Control Ptr = Cast(Control Ptr,GetWindowLong(hWnd,GWL_USERDATA)) ' Zeiger auf Klasse die hWnd sendet
	
	If obj Then
		Function = obj->CtrlMsgFunc(hWnd ,uMsg ,wParam , lParam )
	Else
		Function = DefWindowProc(hWnd ,uMsg ,wParam , lParam )
	EndIf	
	
End Function
Sub Control.Focus
	If this.b_Handle Then 
	 	SetFocus(this.b_Handle)
	EndIf
End Sub
Sub Control.Invalidate
	 If this.b_Handle Then 
	 	InvalidateRect(this.b_Handle,0,TRUE)
	 EndIf
End Sub

Sub Control.Repaint
	 If this.b_Handle Then
	 	 RedrawWindow(this.b_Handle,0,0,RDW_ERASE Or RDW_INVALIDATE Or RDW_FRAME Or RDW_ALLCHILDREN)
	 EndIf
End Sub

Sub Control.setFont(Face As String,ByVal size As Integer,ByVal bold As Integer,ByVal italic As Integer,ByVal underlin As Integer)	
	Dim lgFont AS LOGFONT 
	lgFont.lfFaceName = Face
	lgFont.lfHeight 	= -MulDiv(size, GetDeviceCaps(GetDC(0), LOGPIXELSY), 72)
	lgFont.lfWeight 	= IIf(bold,800,400)
	lgFont.lfItalic 	= IIf(italic,1,0)
	lgFont.lfStrikeOut = 0
	lgFont.lfUnderline = IIf(underlin,1,0)
	If this.b_hFont Then
		DeleteObject(this.b_hFont)
	EndIf
	this.b_hFont = (CreateFontIndirect(@lgFont))
	If this.Handle Then	
		SendMessage(this.Handle,WM_SETFONT,Cast(Uinteger, this.b_hFont),TRUE)
	End If
End Sub
'                                          ###### Ende Basis #######   

'-----------------------------------------------------------------------------------
' Hilfsfunction ( statt FILEEXISTS )
'-----------------------------------------------------------------------------------
Function isFileExist(file As String) As BOOL
	Dim szFile As ZString * MAX_PATH
	Function = FALSE
	szFile = file
	If GetFileAttributes(@szFile) <> &HFFFFFFFF Then
		Function = TRUE
	EndIf
End Function 
'-----------------------------------------------------------------------------------
' Hilfsfunction ( statt FILELEN  )
'-----------------------------------------------------------------------------------
Function isFilesize(file As String) As UInteger

	Dim hFile As HANDLE
	Dim uiSize As UInteger
	
	Function = FALSE
	
	hFile  = CreateFile(@file[0] ,GENERIC_READ or GENERIC_WRITE, 0 , 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0)
	If hFile = INVALID_HANDLE_VALUE Then
		Function = 0
		Exit Function
	EndIf
	uiSize = GetFileSize(hFile,NULL)
	CloseHandle(hFile)
	If uiSize = &HFFFFFFFF Then 	' Fehler
		uiSize = 0
	End If
	Function = uiSize
End Function 
'--------------------------------------------------------------------------------------------------------------------------------------
'	Save Image to File using gdi+ ( wird u.a. in FCanvas verwendet)
'--------------------------------------------------------------------------------------------------------------------------------------
Function GetEncoderClsid( sFormat As String, ByRef retClsid As CLSID ) As Integer
	
	  Using Gdiplus	
	  Dim As ImageCodecInfo Ptr pCodecInf
	  Dim As UInteger nCoder, size , i
	  
	  Function = 0	
	  
	  GdipGetImageEncodersSize( @nCoder, @size )
	  pCodecInf = Callocate( size )
	  
	  If GdipGetImageEncoders( nCoder, size, pCodecInf )=0 Then
	
	    For i = 0 To nCoder - 1
	      If *Cast(WString Ptr,pCodecInf[i].FormatDescription) = sFormat Then
	        retClsid = pCodecInf[i].clsid
	        Function = 1
	      End If
	    Next
	  EndIf
	  If pCodecInf <> 0 Then DeAllocate( pCodecInf )
	End Function
	
	
	Function SaveDCToFile( sFile As String, ByRef dc As HDC, ByVal dcWidth As Integer, ByVal dcHeight As Integer ) As Integer
		
		Function = 0
		
		Using Gdiplus
		DIM AS WSTRING * MAX_PATH wsFilename    
		Dim As GdiplusStartupInput gdipsi
   	Dim As ULONG_PTR gdipToken
   	Dim As GpImage Ptr pIMG
   	Dim As GUID sGuid
   	Dim As HBITMAP hBmp
		Dim As HDC hmemDc,qDC
		Dim As String sTyp
		Dim As Integer i
		
		' Datei-Typ ermitteln ; nicht alle haben nur 3 Zeichen (zB.tiff)
		i = InStrRev(sFile, ".") 
		sTyp = UCase(Mid(sFile,i+1,Len(sFile)-i))
		If sTyp = "JPG" Then sTyp = "JPEG" ' JPG wird nicht erkannt
		
		' MemDC mit Inhalt des DC erstellen zur weitern Verwendung 
		hmemDc=CreateCompatibleDC(dc)
		hBmp  =CreateCompatibleBitmap(dc ,dcWidth, dcHeight)
		SelectObject(hmemDc,hBmp )
		BitBlt(hmemDc,0,0,dcWidth, dcHeight,dc,0,0,SRCCOPY)
		
		DeleteObject(hBmp )	
		hBmp = 0
				
		' Bitmap des DC holen
		hBmp = GetCurrentObject(hmemDc,OBJ_BITMAP)
		If hBmp = 0 Then
			DeleteDC(hmemDc)
			Exit Function
		EndIf
		
		gdipsi.GdiplusVersion = 1 
		If GdiplusStartup( @gdipToken, @gdipsi, null ) <> 0 Then
			DeleteDC(hmemDc)
			Exit Function
		EndIf
		
		If GdipCreateBitmapFromHBITMAP(hBmp,0,@pIMG) <> 0 Then
			GOTO ende1
		EndIf
		
		If GetEncoderClsid ( sTyp, sGuid ) = 0 Then
			MessageBox( 0, "Unbekanntes Dateiformat!", "Fehler", MB_OK Or MB_ICONINFORMATION )
			GOTO ende1
		EndIf
				
		If GdipSaveImageToFile( pIMG, WStr(sFile) , @sGuid , NULL ) = 0 Then		
			Function = 1
		Else
			MessageBox( 0, "Fehler - SaveImageToFile ", "Fehler", MB_OK Or MB_ICONINFORMATION )
		EndIf
		
		ende1:
		GdipDisposeImage(pIMG)
		DeleteObject(hBmp)
		GdiplusShutdown( gdipToken )
		DeleteDC(hmemDc)
		
	End Function
                                   
'--------------------------------------------------------------------------------------------------------------------------------------
'	Load Image fromResource or fromFile using gdi+ ( wird in FCanvas,FButton und FToolBtn verwendet)
'--------------------------------------------------------------------------------------------------------------------------------------
Function ImgLoadFromRes(resName As String,ByVal bkColor As UInteger, ByRef tDC As HDC,ByRef w As Integer,ByRef h As Integer) As Integer
	 
	Function = 0
	Using Gdiplus
	
	Dim As GdiplusStartupInput gdipsi
   Dim As ULONG_PTR gdipToken
   Dim As GpGraphics Ptr pGraph
   Dim As GpImage Ptr pImg
   Dim As Integer iw,ih
	Dim As LPSTREAM pImageStream 
	Dim As HINSTANCE hInst
   Dim As ZString * 128 szRes 
   Dim As HBITMAP hBmp
   Dim As BITMAP bm
   Dim As HRSRC hResource
  
	
	hInst 	= GetModuleHandle(0)
	szRes		= resName
	
	hResource = FindResource(hInst, cast( LPCSTR, @szRes ), BYVAL RT_RCDATA)
	IF hResource = NULL Then
		hResource = FindResource(hInst, cast( LPCSTR, @szRes ), BYVAL RT_BITMAP)
		IF hResource = NULL Then
			MessageBox( null, "Fehler - Resource ist nicht gefunden", "Error", MB_ICONERROR )
			Exit Function
		End If
		Dim As HDC tmpDC = GetDC(GetDesktopWindow)
		tDc = CreateCompatibleDC(tmpDC)
		ReleaseDC(GetDesktopWindow,tmpDc)
		hBmp =  LoadBitmap(hInst,@szRes)
		If hBmp Then
			GetObject(hBmp,SizeOf(bm),@bm)
			w = bm.bmWidth
			h = bm.bmHeight	
			SelectObject(tDc,hBmp)
			DeleteObject(hBmp)
			Function = 1
			Exit Function
		Else
			Exit Function
		EndIf			
	EndIf
	
	gdipsi.GdiplusVersion = 1 
	If GdiplusStartup( @gdipToken, @gdipsi, null ) <> 0 Then
		Exit Function
	EndIf
	
	Dim As Integer imgSize = SizeofResource(hInst, hResource)
	If imgSize = 0 THEN 
		GdiplusShutdown( gdipToken )
		Exit Function
	EndIf
	Dim As LPVOID pResourceData = LockResource(LoadResource(hInst, hResource))
	IF pResourceData = NULL THEN 
		GdiplusShutdown( gdipToken )
		Exit Function
	EndIf

	Dim As HGLOBAL hGlobal = GlobalAlloc(GMEM_MOVEABLE, imgSize)
	If hGlobal THEN 
   	Dim As LPVOID pGlobalBuffer = GlobalLock(hGlobal)
   	If pGlobalBuffer Then
      	CopyMemory( pGlobalBuffer, pResourceData, imgSize) 
      	IF CreateStreamOnHGlobal(hGlobal, FALSE, @pImageStream) = S_OK Then
            If GdipCreateBitmapFromStream(pImageStream, @pImg) = 0 Then
            	If GdipGetImageWidth (pImg, @iw) = 0 Then
						w = iw
            	EndIf
					If GdipGetImageHeight (pImg, @ih) = 0 Then
						h = ih
					EndIf
					If (h Or w) = 0 Then
						GlobalUnlock(pGlobalBuffer)
						GlobalFree(hGlobal)
						GdipDisposeImage( pImg)
						GdiplusShutdown( gdipToken )
						Exit Function
					EndIf
					
					Dim As HDC tmpDC = GetDC(GetDesktopWindow)
					tDc = CreateCompatibleDC(tmpDC)
					hBmp = CreateCompatibleBitmap(tmpDC,w,h)
					SelectObject(tDc,hBmp)
					DeleteObject(hBmp)
					ReleaseDC(GetDesktopWindow,tmpDc)
					
					GdipCreateFromHDC(tDc , @pGraph)
					If bkColor > 0 Then
						GdipGraphicsClear(pGraph,bkColor)
					End If	
					GdipDrawImageRect(pGraph, pImg, 0, 0, w, h)
					Function = 2
           		pImageStream = NULL
            EndIf
      		GlobalUnlock(pGlobalBuffer)
      	EndIf
   	GlobalFree(hGlobal)
   	EndIf
	EndIf 	
	
	'Image und Objekt freigeben
	GdipDisposeImage( pImg)
	GdipDeleteGraphics(pGraph)
	GdiplusShutdown( gdipToken )	
End Function

Function ImgLoadFromFile(s As String,ByVal bkColor As UInteger, ByRef tDC As HDC,ByRef w As Integer,ByRef h As Integer) As Integer
	Function = 0
	Using Gdiplus
	
	Dim As GdiplusStartupInput gdipsi
   Dim As ULONG_PTR gdipToken
   Dim As GpGraphics Ptr pGraph
   Dim As GpImage Ptr pImg
	Dim As HBITMAP bitmap
	Dim As UInteger iw,ih
	
		
	gdipsi.GdiplusVersion = 1 
	If GdiplusStartup( @gdipToken, @gdipsi, null ) <> 0 Then
		Exit Function
	EndIf
	If GdipLoadImageFromFile( WStr(s), @pImg) <> 0 Then
  		GdiplusShutdown( gdipToken )
  		Exit Function
	EndIf
	
	If GdipGetImageWidth (pImg, @iw) = 0 Then
		w = iw 
	EndIf
	If GdipGetImageHeight (pImg, @ih) = 0 Then
		h = ih
	EndIf
			
	Dim As HDC tmpDC = GetDC(GetDesktopWindow)
   tDC = CreateCompatibleDC(tmpDC)
   bitmap = CreateCompatibleBitmap(tmpDC,w,h)
	SelectObject(tDC,bitmap)
	
	ReleaseDC(GetDesktopWindow,tmpDc)
	DeleteObject(bitmap)
	
	GdipCreateFromHDC(tDC  , @pGraph)
	If bkColor > 0 Then
		GdipGraphicsClear(pGraph,bkColor)
	End If	
	GdipDrawImageRect(pGraph, pImg, 0, 0, w, h)
	Function = 1
		
	'Image und Objekt freigeben
	GdipDisposeImage( pImg)
	GdipDeleteGraphics(pGraph)
	GdiplusShutdown( gdipToken )	
	
End Function
'--------------------------------------------------------------------------------
' Ld ein Image from File und zeichnet es sofort in den hDC
'--------------------------------------------------------------------------------
Function DrawImageFromFile(s As String,ByVal zielDC As HDC,ByVal x As Integer,ByVal y As Integer,ByVal w As Integer,ByVal h As Integer) As Integer
	Function = 0
	Using Gdiplus
	
	Dim As GdiplusStartupInput gdipsi
   Dim As ULONG_PTR gdipToken
   Dim As PVOID pGraph, pImg
	Dim As UInteger iw,ih
	
		
	gdipsi.GdiplusVersion = 1 
	If GdiplusStartup( @gdipToken, @gdipsi, null ) <> 0 Then
		Exit Function
	EndIf
	' Bild aus Datei lesen
	If GdipLoadImageFromFile( WStr(s), @pImg) <> 0 Then
  		GdiplusShutdown( gdipToken )
  		Exit Function
	EndIf
	' Bildabmessungen lesen
	If GdipGetImageWidth (pImg, @iw) <> 0 Then
		GdipDisposeImage( pImg)
		GdiplusShutdown( gdipToken )
  		Exit Function
	EndIf
	GdipGetImageHeight (pImg, @ih)
	' Wenn h und w null dann orginal Bildgre
	If (w=0) And (h=0) Then
		 w = iw
		 h = ih
	End If
	' Vom ZielDC ein Graphic Object erstellen 
	GdipCreateFromHDC(zielDC  , @pGraph)
	GdipDrawImageRect(pGraph, pImg, x, y, w, h)
	Function = 1
		
	'Image und Objekt freigeben
	GdipDisposeImage( pImg)
	GdipDeleteGraphics(pGraph)
	GdiplusShutdown( gdipToken )	
	
End Function
'--------------------------------------------------------------------------------
' Ld ein Image from Resource und zeichnet es sofort in den hDC
'--------------------------------------------------------------------------------
Function DrawImageFromRes(s As String,ByVal zielDC As HDC,ByVal x As Integer,ByVal y As Integer,ByVal w As Integer,ByVal h As Integer) As Integer
	 
	Function = 0
	Using Gdiplus
	
	Dim As GdiplusStartupInput gdipsi
   Dim As ULONG_PTR gdipToken
   Dim As PVOID pGraph,pImg
   Dim As Integer iw,ih
	Dim As LPSTREAM pImageStream 
	Dim As HINSTANCE hInst
   Dim As ZString * 128 szRes 
   Dim As HRSRC hResource
  
	
	hInst 	= GetModuleHandle(0)
	szRes		= s
	
	hResource = FindResource(hInst, cast( LPCSTR, @szRes ), BYVAL RT_RCDATA)
	IF hResource = NULL Then
		MessageBox(0,"Resource nicht gefunden","Fehler",MB_ICONERROR)
		Exit Function
	EndIf
	
	gdipsi.GdiplusVersion = 1 
	If GdiplusStartup( @gdipToken, @gdipsi, null ) <> 0 Then
		Exit Function
	EndIf
	
	Dim As Integer imgSize = SizeofResource(hInst, hResource)
	If imgSize = 0 THEN 
		GdiplusShutdown( gdipToken )
		Exit Function
	EndIf
	
	Dim As LPVOID pResourceData = LockResource(LoadResource(hInst, hResource))
	IF pResourceData = NULL THEN 
		GdiplusShutdown( gdipToken )
		Exit Function
	EndIf

	Dim As HGLOBAL hGlobal = GlobalAlloc(GMEM_MOVEABLE, imgSize)
	If hGlobal THEN 
   	Dim As LPVOID pGlobalBuffer = GlobalLock(hGlobal)
   	If pGlobalBuffer Then
      	CopyMemory( pGlobalBuffer, pResourceData, imgSize) 
      	IF CreateStreamOnHGlobal(hGlobal, FALSE, @pImageStream) = S_OK Then
      		
            If GdipCreateBitmapFromStream(pImageStream, @pImg) = 0 Then
            	If GdipGetImageWidth (pImg, @iw) = 0 Then
						GdipGetImageHeight (pImg, @ih)	
					EndIf
					If (ih Or iw) = 0 Then
						GlobalUnlock(pGlobalBuffer)
						GlobalFree(hGlobal)
						GdipDisposeImage( pImg)
						GdiplusShutdown( gdipToken )
						Exit Function
					EndIf
					' Wenn h und w null dann orginal Bildgre
					If (w=0) And (h=0) Then
						 w = iw
						 h = ih
					End If
					' Vom ZielDC ein Graphic Object erstellen 
					GdipCreateFromHDC(zielDC  , @pGraph)
					GdipDrawImageRect(pGraph, pImg, x, y, w, h)
					Function = 1
           		pImageStream = NULL
            EndIf
            
      		GlobalUnlock(pGlobalBuffer)
      	EndIf
   	GlobalFree(hGlobal)
   	EndIf
	EndIf 	
	
	'Image und Objekt freigeben
	GdipDisposeImage( pImg)
	GdipDeleteGraphics(pGraph)
	GdiplusShutdown( gdipToken )	
End Function


'------------------------------------------------------------------------------------------
' Bitmap oder Icon Laden + Handle  bereit stellen
'------------------------------------------------------------------------------------------
Type FBILoad Extends Object  	
  	Public:
	Declare Property bWidth() As Integer					
   Declare Property bWidth( ByVal x As Integer )		
  	Declare Property bHeight() As Integer					
   Declare Property bHeight( ByVal x As Integer )		
   Declare Property bBitmap() As HBITMAP					
   Declare Property bIcon() As HICON	
   Declare Sub LoadBitmapFile( filename As String) 
	Declare Sub LoadIconFile( filename As String)  
	Declare Sub LoadBitmapRes( filename As String) 
	Declare Sub LoadIconRes( filename As String) 
	Declare Function CopyhBitmap As HBITMAP
	Declare Function CopyhIcon As HICON 
	Declare DESTRUCTOR  
	Private:
   As Integer 	w 	 			= 0
  	As Integer 	h    			= 0
   As HBITMAP	b_Bitmap 	= 0
   As HICON		b_Icon	 	= 0
End Type

DESTRUCTOR FBILoad
	If this.b_Bitmap Then
		DeleteObject(this.b_Bitmap)
		this.b_Bitmap = 0
	EndIf
End Destructor
Property FBILoad.bWidth() As Integer
  Return this.w
End Property
Property FBILoad.bWidth( ByVal x As Integer )
  this.w = x
End Property
Property FBILoad.bHeight() As Integer
  Return this.h
End Property
Property FBILoad.bHeight( ByVal x As Integer )
  this.h = x
End Property

Property FBILoad.bBitmap() As HBITMAP	
	Return this.b_Bitmap
End Property
Property FBILoad.bIcon() As HICON	
	Return this.b_Icon
End Property
Sub FBILoad.LoadBitmapFile( filename As String) 
	Dim szFile As ZString * 128
	Dim As BITMAP bm
	
	If isFileExist(filename) = FALSE Then
		Exit sub
	EndIf
	szFile = filename
	If this.b_Bitmap Then
		DeleteObject(this.b_Bitmap)
	EndIf
	
	this.b_Bitmap = LoadImage(NULL,@szFile,IMAGE_BITMAP,0,0,LR_DEFAULTCOLOR Or LR_LOADFROMFILE )
	
	If this.b_Bitmap Then
		GetObject(this.b_Bitmap,SizeOf(bm),@bm)
		this.w = bm.bmWidth
		this.h = bm.bmHeight		
	EndIf
End Sub
Sub FBILoad.LoadIconFile( filename As String)  
	Dim szFile As ZString * 128
	If isFileExist(filename) = FALSE Then
		Exit sub
	EndIf
	szFile = filename
	this.b_Icon = LoadImage(NULL,@szFile,IMAGE_ICON,0,0,LR_DEFAULTCOLOR Or LR_LOADFROMFILE )
	If this.b_Icon Then
		this.w = GetSystemMetrics(SM_CXICON)
		this.h = GetSystemMetrics(SM_CYICON)	
	EndIf
End Sub
Sub FBILoad.LoadBitmapRes( resname As String) 
	Dim szFile As ZString * 128
	Dim As HINSTANCE hInst = GetModuleHandle(0)
	Dim As BITMAP bm
	
	If this.b_Bitmap Then
		DeleteObject(this.b_Bitmap)
	EndIf
	szFile = resname
	this.b_Bitmap = LoadImage(hInst,@szFile,IMAGE_BITMAP,0,0,LR_DEFAULTCOLOR )
	If this.b_Bitmap Then
		GetObject(this.b_Bitmap,SizeOf(bm),@bm)
		w = bm.bmWidth
		h = bm.bmHeight		
	EndIf	
End Sub
Sub FBILoad.LoadIconRes( resname As String) 
	Dim szFile As ZString * 128
	Dim As HINSTANCE hInst = GetModuleHandle(0)
	szFile = resname
	this.b_Icon = LoadImage(hInst,@szFile,IMAGE_ICON,0,0,LR_DEFAULTCOLOR  )
	If this.b_Icon Then
		this.w = GetSystemMetrics(SM_CXICON)
		this.h = GetSystemMetrics(SM_CYICON)	
	EndIf
End Sub
Function FBILoad.CopyhBitmap As HBITMAP	
	Return CopyImage(this.b_Bitmap,IMAGE_BITMAP,this.w,this.h,LR_COPYDELETEORG)
End Function
Function FBILoad.CopyhIcon As HICON
	Return CopyImage(this.b_Bitmap,IMAGE_ICON,this.w,this.h,LR_COPYDELETEORG)
End Function


'=========================================================================================================