'---------------------------------------------------------------------------------------------------------
' Label Control
'---------------------------------------------------------------------------------------------------------

Type FLabel Extends Control
	
	public:
	
   Declare Property Border() As Integer							
   Declare Property Border( ByVal value As Integer )			
  	Declare Property Align() As Integer							
   Declare Property Align( ByVal value As Integer )			
     
   
   Declare Sub Create(ByVal hParent As HWND,capt As String, ByVal x As Integer,ByVal y As Integer,ByVal w As Integer,ByVal h As Integer )
   Declare Constructor
   Declare Destructor 
   Declare Function CtrlMsgFunc(hWnd As HWND,uMsg as UINT,wParam as wParam,lParam as lParam) as LRESULT
   
   Private:
 	As HBRUSH   b_Brush	= 0	
	As Integer  b_Border	= 0 ' ohne
	As Integer  b_Align	= 0 ' links
End Type
Constructor FLabel	
  	this.Handle  = 0
End Constructor

Destructor FLabel
   this.Handle  = 0
End Destructor

   
Property FLabel.Border() As Integer
	Return this.b_Border
End Property
Property FLabel.Border( ByVal value As Integer )
	Dim As UInteger lStyle,lExStyle

	Select Case Value
		Case 0	' ohne
			this.b_Border = 0
			lStyle 	= WS_CHILD Or SS_LEFT Or WS_VISIBLE
			lExStyle	= 0
		Case 1	' Sunken
			this.b_Border = 1
			lStyle 	= WS_CHILD Or SS_LEFT Or WS_VISIBLE
			lExStyle	= WS_EX_CLIENTEDGE 
		Case 2	' Rahmen
			this.b_Border = 2
			lStyle 	= WS_CHILD Or SS_LEFT Or WS_VISIBLE Or WS_BORDER
			lExStyle	= 0
	End Select
	If this.Handle Then
		SetWindowLong(this.Handle, GWL_STYLE,lStyle)
		SetWindowLong(this.Handle, GWL_EXSTYLE,lExStyle)
  		SetWindowPos(this.Handle,0,0,0,this.Width,this.Height,SWP_DRAWFRAME Or SWP_FRAMECHANGED)
	End If	
End Property
Property FLabel.Align() As Integer
	Return this.b_Align
End Property
Property FLabel.Align( ByVal value As Integer )
	Dim As UInteger lStyle
	If this.Handle Then
  		lStyle = GetWindowLong(this.Handle, GWL_STYLE)
	End If	
	Select Case Value
		Case 0	' links
			this.b_Align = 0
			lStyle = lStyle And (Not SS_CENTER )
			lStyle = lStyle And (Not SS_RIGHT )
			lStyle = lStyle Or SS_LEFT 
		Case 1	' mitte
			this.b_Align = 1
			lStyle = lStyle And (Not SS_LEFT )
			lStyle = lStyle And (Not SS_RIGHT )
			lStyle = lStyle Or SS_CENTER  
			
		Case 2	' rechts
			this.b_Align = 2
			lStyle = lStyle And (Not SS_LEFT )
			lStyle = lStyle And (Not SS_CENTER )
			lStyle = lStyle Or SS_RIGHT   
	End Select
	If this.Handle Then
		SetWindowLong(this.Handle, GWL_STYLE,lStyle)
  		SetWindowPos(this.Handle,0,0,0,this.Width,this.Height,SWP_DRAWFRAME Or SWP_FRAMECHANGED)
	End If	
End Property
Function FLabel.CtrlMsgFunc(hWnd As HWND,uMsg as UINT,wParam as wParam,lParam as lParam) as LRESULT
	
   Function = 0 
  
   Select case uMsg   	
    	Case WM_ENABLE 
   		this.Enabled = wParam
   		Exit Function
   		
   	Case WM_SETFONT,WM_SETTEXT
   		If this.Handle Then
   			Function = SendMessage(this.Handle,uMsg,wParam,lParam)
   		End If
    		Exit Function 
    		
   	Case WM_SIZE
   		If this.Handle Then
    			MoveWindow(this.Handle,0,0,LOWORD(lParam),HiWord(lParam),TRUE)
   		End If
    		Exit Function 
    		
   	Case WM_CTLCOLORSTATIC
   		'(HDC) wParam
   		SetBkMode(Cast(HDC,wParam),TRANSPARENT)
   		SetTextColor(Cast(HDC,wParam),this.TextColor)
   		If this.b_Brush then
   			DeleteObject(this.b_Brush)
   		End If	
   		this.b_Brush = CreateSolidBrush(this.Color)
   		Function = CInt(this.b_Brush)
   		Exit Function
   		
   	Case WM_DESTROY
   		If this.b_Brush then
   			DeleteObject(this.b_Brush)
   		End If	
   		Function = 0
			Exit Function   	
   End Select
  
   Function = DefWindowProc(hWnd,uMsg,wParam,lParam)
end Function

'
Sub FLabel.Create(ByVal hParent As HWND, capt As String,  ByVal x As Integer,ByVal y As Integer,ByVal w As Integer,ByVal h As Integer )
	
	Dim As ZString * 32 szClass
   Dim As HINSTANCE hInst
 	
   szClass     = "FB_CONTROL"
   hInst 		= GetModuleHandle(0)
   
   this.CtHandle = CreateWindowEx( WS_EX_CONTROLPARENT  , @szClass , "", WS_VISIBLE Or WS_CHILD  , x, y, w , h , _                    
                          hParent , NULL, hInst , NULL )
                                                   
   SetWindowLong(this.CtHandle ,GWL_USERDATA,CInt(@This)) ' Zeiger diese Instanz                        
                                                                    
   If this.CtHandle  Then  		
   	this.Left	 = x
		this.Top		 = y
   	this.Width 	 = w
  		this.Height  = h
   	this.Parent  = hParent  	
   Else
   	MessageBox(0,"Fehler - Create Label","Fehler",MB_ICONERROR)
   	Exit Sub
   End If
                               
   this.Handle = CreateWindowEx( NULL , "STATIC" , Capt, this.Style  ,  0, 0, w, h , this.CtHandle , NULL, hInst , NULL )  
   this.Caption = Capt                                            
   If this.Handle = 0 Then
   	MessageBox(0,"Fehler - Create Label","Fehler",MB_ICONERROR)
   EndIf  
  
   
End Sub