'#include once "win\GdiPlus.bi"

Type FLabelEx Extends Control	
  	Public:
  	
  	Declare Property BorderWidth() As Integer						
   Declare Property BorderWidth( ByVal value As Integer )
   Declare Property BorderColor() As UInteger						
   Declare Property BorderColor( ByVal value As UInteger )
   Declare Property TextBorderWidth() As Integer						
   Declare Property TextBorderWidth( ByVal value As Integer )
   Declare Property TextBorderColor() As UInteger						
   Declare Property TextBorderColor( ByVal value As UInteger )
   Declare Property TextEndColor() As UInteger						
   Declare Property TextEndColor( ByVal value As UInteger )
   Declare Property TextGradients() As Integer						
   Declare Property TextGradients( ByVal value As Integer )
   Declare Property TextColor() As UInteger	Override
   Declare Property TextColor( ByVal value As UInteger ) Override
	Declare Property TextAlign() As Integer	
   Declare Property TextAlign( ByVal value As Integer )
   
   Declare Sub Create(ByVal hParent As HWND, ByVal x As Integer,ByVal y As Integer,ByVal w As Integer,ByVal h As Integer )
   Declare Constructor
   Declare Destructor
      
   Declare  Function CtrlMsgFunc(hWnd As HWND,uMsg as UINT,wParam as wParam,lParam as lParam) as LRESULT
	Private:
	As UInteger 	b_TextColor 		= &HFF000000
	As UInteger 	b_TextEndColor 	= &H0
	As Integer		b_TextGradients 	= 0
	As Integer  	b_BorderWidth 		= 0
	As UInteger 	b_BorderColor 		= &H0
   As Integer  	b_TextBorderWidth	= 0
	As UInteger 	b_TextBorderColor = &H0
	As HPEN			b_pen = 0
	As HBRUSH		b_brush = 0
	As ULONG_PTR	b_hGdiPlus = 0
	As Integer		b_NoTextColor	 	= FALSE
	As Integer		b_TextAlign			= 1 ' Mitte
End Type

Constructor FLabelEx
	Using GDIPLUS
	Dim GDIPLUSSTARTUPINPUT_01 As GDIPLUSSTARTUPINPUT
	GDIPLUSSTARTUPINPUT_01.GdiplusVersion = 1
	If (GdiplusStartup(@b_hGdiPlus, @GDIPLUSSTARTUPINPUT_01, NULL) <> 0) Then
		MessageBox(0,"GDI+ ist nicht verfgbar","Fehler",MB_ICONERROR)
	EndIf
	
	this.setFont("Arial",10,0,0,0)	
	this.Handle = 0
	this.Style 	= WS_CHILD OR WS_VISIBLE 
	this.ExStyle = WS_EX_TRANSPARENT 
	            
End Constructor

Destructor FLabelEx	
   this.Handle  = 0
End Destructor

Property FLabelEx.BorderWidth() As Integer		
	Return this.b_BorderWidth
End Property
Property FLabelEx.BorderWidth( ByVal value As Integer )
	this.b_BorderWidth = value
End Property
Property FLabelEx.BorderColor() As UInteger		
	Return this.b_BorderColor
End Property
Property FLabelEx.BorderColor( ByVal value As UInteger )
	this.b_BorderColor = value
End Property
Property FLabelEx.TextBorderWidth() As Integer		
	Return this.b_TextBorderWidth
End Property
Property FLabelEx.TextBorderWidth( ByVal value As Integer )
	this.b_TextBorderWidth = value
End Property
Property FLabelEx.TextBorderColor() As UInteger	
	Return this.b_TextBorderColor
End Property
Property FLabelEx.TextBorderColor( ByVal value As UInteger )
	Dim As UShort r,g,b
	r =  GetRValue(value)
	g =  GetGValue(value)
	b =  GetBValue(value)
	this.b_TextBorderColor =  RGBA(r,g,b,&HFF) 
End Property
Property FLabelEx.TextEndColor() As UInteger		
	Return this.b_TextEndColor 
End Property
Property FLabelEx.TextEndColor( ByVal value As UInteger )
	Dim As UShort r,g,b
	r =  GetRValue(value)
	g =  GetGValue(value)
	b =  GetBValue(value)
	this.b_TextEndColor =  RGBA(r,g,b,&HFF) 
End Property
Property FLabelEx.TextGradients() As Integer					
	Return this.b_TextGradients
End Property
Property FLabelEx.TextGradients( ByVal value As Integer )
	this.b_TextGradients = value
End Property
Property FLabelEx.TextColor() As UInteger	
	Return this.b_TextColor 
End Property
Property FLabelEx.TextColor( ByVal value As UInteger )
	If value = -1 Then 
		b_NoTextColor = TRUE
	Else
		Dim As UShort r,g,b
		r =  GetRValue(value)
		g =  GetGValue(value)
		b =  GetBValue(value)
		this.b_TextColor = RGBA(r,g,b,&HFF) 
		b_NoTextColor = FALSE
	EndIf
End Property
Property FLabelEx.TextAlign() As Integer	
	Return this.b_TextAlign
End Property
Property FLabelEx.TextAlign( ByVal value As Integer )
	this.b_TextAlign = value
End Property
   
Function FLabelEx.CtrlMsgFunc(hWnd As HWND,uMsg as UINT,wParam as wParam,lParam as lParam) as LRESULT 

	Using GDIPLUS
	
	Dim As RECT rc
	Function = 0
	
  	Select Case uMsg
  		CASE WM_ENABLE
         this.Enabled = wParam
         EXIT Function
         
         
  		CASE WM_PAINT
         dim pnt as PAINTSTRUCT
       	Dim As HDC hDC
       	Dim As WString * 255 wszCaption 
       	Dim As RectF boundRect,desRect
       	Dim As PVOID GpGraphics,GpPen,Gppath,Gpbrush,GpfontFamily,GpFont,GpFormat
       	Dim As LOGFONT lf
       	Dim As Integer fntHeight, fntStyle
       	Dim As UInteger bkColor 
       	Dim As UShort r,g,b
       	Dim As GpPointF p1,p2
       	
         hDC = BeginPaint( hWnd, @pnt )
         ' Graphics Object erstellen         
         GdipCreateFromHDC(hDC,@GpGraphics)
			GdipSetSmoothingMode (GpGraphics,SmoothingModeAntiAlias)
			
			' Hintergrundfarbe Control
			If this.Color <> -1 Then
				r =  GetRValue(this.Color)
				g =  GetGValue(this.Color)
				b =  GetBValue(this.Color)
				bkColor = RGBA(r,g,b,&HFF)
				GdipGraphicsClear(GpGraphics,bkColor)
			EndIf
			
         ' Label Umrandung
          If this.b_BorderWidth > 0 Then
          	DeleteObject(SelectObject(hDC,GetStockObject(HOLLOW_BRUSH)))
         	this.b_pen = CreatePen(PS_SOLID,this.b_BorderWidth,this.b_BorderColor)
         	DeleteObject(SelectObject(hDC,this.b_pen))
         	If this.b_BorderWidth > 1 then
         		Rectangle(hDC,1,1,this.Width,this.Height)
         	Else
         		Rectangle(hDC,0,0,this.Width,this.Height)
         	EndIf	
         EndIf
         
         ' Schrift in den DC setzen
         DeleteObject(SelectObject(hDc,this.Font)) 
         ' Attr. lesen
        	GetObject(this.Font,SizeOf(lf),@lf)
   		wszCaption  = WStr(lf.lfFaceName)
   		fntHeight=Abs(lf.lfHeight)
   		
   		fntStyle = 0
   		If (lf.lfWeight > 400) And (lf.lfItalic > 0) Then
   			fntStyle = 3
   		EndIf
   		If (lf.lfWeight < 500) And (lf.lfItalic > 0) Then
   			fntStyle = 2
   		EndIf
   		If (lf.lfWeight > 400) And (lf.lfItalic = 0) Then
   			fntStyle = 1
   		EndIf
   		
       	If GdipCreateFontFamilyFromName(@wszCaption[0],NULL,@GpfontFamily) = 0 Then	
				 GdipCreateFont(GpfontFamily, fntHeight, fntStyle , UnitPixel , @Gpfont) 	
       	Else
				MessageBox(0," GDI+ GdipCreateFontFromDC ","Fehler",MB_ICONERROR)
   			GdipDeleteGraphics(GpGraphics)
				Exit Function
       	EndIf
       	' 0:links , 1:mitte, 2:rechts	
   		If GdipCreateStringFormat(0, LANG_NEUTRAL, @GpFormat) = 0 Then
   			Select Case this.TextAlign
   				Case 0
   					GdipSetStringFormatAlign(GpFormat, StringAlignmentNear)
   				Case 1
   					GdipSetStringFormatAlign(GpFormat, StringAlignmentCenter) ' voreingestellt
   				Case 2
   					GdipSetStringFormatAlign(GpFormat, StringAlignmentFar)
   			End Select	
			Else
				MessageBox(0," GdipCreateStringFormat","Fehler",MB_OK)
				GdipDeleteGraphics(GpGraphics)
				Exit Function
   		EndIf	
   		
			desRect.x = 0 					  : desRect.y = 0
			desRect.Height = this.Height : desRect.Width = this.Width
			' 	
			wszCaption  = WStr(this.Caption)	
			If GdipMeasureString(GpGraphics,@wszCaption[0],LEN(wszCaption) ,GpFont, @desRect, GpFormat, @boundRect, 0, 0) <> 0 Then
				MessageBox(0,"GdipMeasureString","Fehler",MB_OK)
			EndIf
			'' VertCenter
			If this.Height > boundRect.Height + this.b_BorderWidth Then
				boundRect.Y	= ((this.Height - boundRect.Height)/2) + this.b_BorderWidth 
			EndIf
			
		
   		' ----------- Create Path -------------------------
			GdipCreatePath(FillModeAlternate,@Gppath)			
			If GdipAddPathString (Gppath,@wszCaption,-1, GpfontFamily , fntStyle  , fntHeight , @boundRect, 0) <> 0 Then
				MessageBox(0,"GDI+ GdipAddPathString","Fehler",MB_ICONERROR)
			EndIf
			
			If this.b_NoTextColor = FALSE Then
				Select Case this.b_TextGradients
					Case 0 
						GdipCreateSolidFill(this.TextColor,@Gpbrush)
						GdipFillPath(GpGraphics,Gpbrush, Gppath) 	' Schriftfllfarbe
					Case 1
						p1.x=boundRect.X	: p1.y=boundRect.Y
	 					p2.x=boundRect.X + boundRect.Width
	 					p2.y=boundRect.Height + p1.y=boundRect.Y
						GdipCreateLineBrush(@p1,@p2,this.TextColor,this.TextEndColor,WrapModeTile,@Gpbrush)
						GdipFillPath(GpGraphics,Gpbrush, Gppath) 	' Schriftfllfarbe
					Case 2
						p1.x=0 :	p1.y=boundRect.Y
	 					p2.x=0 : p2.y=boundRect.Height + boundRect.Y
						GdipCreateLineBrush(@p1,@p2,this.TextColor,this.TextEndColor,WrapModeTile,@Gpbrush)
						GdipFillPath(GpGraphics,Gpbrush, Gppath)	' Schriftfllfarbe
				End Select
			EndIf 
			
			If this.b_TextBorderWidth > 0 Then	
				GdipCreatePen1(this.TextBorderColor,this.b_TextBorderWidth,Unitpixel,@GpPen)
				GdipDrawPath(GpGraphics,GpPen, Gppath)	 ' Schriftumrandung
			EndIf
			'---------------- Bereinigen -------------------------------
			
			If GpPen Then
				GdipDeletePen(GpPen)
			End If
			If Gpbrush Then
				GdipDeleteBrush(Gpbrush)
			End If
			
			GdipDeleteStringFormat(GpFormat)
			GdipDeletePath(Gppath)
			GdipDeleteFont(GpFont)
			GdipDeleteFontFamily(GpfontFamily)
			GdipDeleteGraphics(GpGraphics)
			
		   EndPaint( hWnd, @pnt )  
         EXIT FUNCTION  
         '------------------------------------------
  		Case WM_DESTROY
  			If this.b_pen Then
  				DeleteObject(this.b_pen)
  			EndIf
         If this.b_brush Then
  				DeleteObject(this.b_brush)
         EndIf
         If this.b_hGdiPlus <> 0 Then
				GdiplusShutdown(this.b_hGdiPlus)
         EndIf
         Exit Function
         
  	End select	
   
    Function = DefWindowProc(hWnd,uMsg,wParam,lParam)
End Function

Sub FLabelEx.Create(ByVal hParent As HWND, ByVal x As Integer,ByVal y As Integer,ByVal w As Integer,ByVal h As Integer )

   Dim As ZString * 32 szClass
   Dim As HINSTANCE 	hInst
 	
   szClass     = "FB_CONTROL"
   hInst 		= GetModuleHandle(0)
         
   this.Handle = CreateWindowEx(this.ExStyle , @szClass , "", this.Style  , x, y, w , h , _                    
                          hParent , NULL, hInst , NULL )
                                                   
                                                                    
   If this.Handle  Then 
   	SetWindowLong(this.Handle ,GWL_USERDATA,CInt(@This)) ' Zeiger diese Instanz  
   	SetClassLong( this.Handle ,GCL_HBRBACKGROUND,CInt(GetStockObject(HOLLOW_BRUSH )))                      
   	repaint
   	this.Left	 = x
		this.Top		 = y
   	this.Width 	 = w
  		this.Height  = h
   	this.Parent  = hParent  	
   Else
   	MessageBox(0,"Fehler - TabControl Container","Fehler",MB_ICONERROR)
   	Exit Sub
   End If
  
End Sub