'--------------------------------------------------------------------
' Progress
'--------------------------------------------------------------------
Type FProgress Extends Control	
	public: 	
	Declare Property Border As Integer
	Declare Property Border(ByVal value As Integer)
	Declare Property ProgressColor As UInteger
	Declare Property ProgressColor(ByVal value As UInteger)
	Declare Property Pos As Integer
	Declare Property Pos(ByVal value As Integer)
	Declare sub Stepit
	Declare Sub SetStep(ByVal value As integer )
	Declare sub SetRange(ByVal min As  USHORT ,ByVal max As  USHORT )	   
   Declare Sub Create(ByVal hParent As HWND, ByVal x As Integer,ByVal y As Integer,ByVal w As Integer,ByVal h As Integer )
   Declare Constructor
   Declare Destructor 
   As UInteger b_DrawPos= 0
   As UInteger b_Step	= 10
   As UInteger b_CurPos	= 0
   As UInteger b_min		= 0
   As UInteger b_max		= 100
   
   'events
   onLButtondown As Sub(ByVal x As Short, ByVal y As Short)
	onRButtondown As Sub(ByVal x As Short, ByVal y As Short)

   Private:
   DECLARE static FUNCTION ProgressSubClass(hWnd AS HWND,uMsg AS UINT,wParam AS wParam,lParam AS lParam) AS LRESULT  
   As UInteger b_oldProc	= 0 
   As Integer  b_Border		= TRUE
   As UInteger b_ProgressColor = &HFF0000
  
End Type
Constructor FProgress
	
	If InitCommon = 0 Then 
		InitCommonControls
		InitCommon = 1
	EndIf
	
  	this.Handle  = 0
  	this.ExStyle = 0	
	this.Style 	 =  WS_CHILD 
	
end Constructor

Destructor FProgress
   this.Handle  = 0
End Destructor

Property FProgress.Border As Integer
	Return this.b_Border
End Property
Property FProgress.Border(ByVal value As Integer)
	this.b_Border = IIf(value,TRUE,FALSE)
	If this.b_Border Then
		SetWindowLong(this.Handle ,GWL_EXSTYLE,WS_EX_CLIENTEDGE )
	Else
		SetWindowLong(this.Handle ,GWL_EXSTYLE,0)
	EndIf
	Repaint
End Property
Property FProgress.ProgressColor As UInteger
	Return this.b_ProgressColor
End Property
Property FProgress.ProgressColor(ByVal value As UInteger)
	this.b_ProgressColor = value
End Property
Property FProgress.pos(ByVal value As Integer)	
	If this.Handle Then
		If value <= b_max Then 
 			b_CurPos = Int(value/b_Step) * b_Step ' auf b_Step Position
			b_DrawPos = Int((this.Width / b_max) * b_CurPos)
			Invalidate
		End If
	EndIf
End Property	
Property FProgress.pos  As Integer	
	If this.Handle Then
		Return this.b_CurPos
	EndIf
End Property	
sub FProgress.Stepit
	If this.Handle Then
		b_CurPos = b_CurPos + b_Step
		If b_CurPos > b_max  Then b_CurPos = 0
		b_DrawPos = Int((this.Width / b_max) * b_CurPos)
		Invalidate
	EndIf
End Sub
sub FProgress.SetStep(ByVal value As integer )
	If this.Handle Then		
		b_Step = value 
	EndIf
End Sub

Sub FProgress.SetRange(ByVal min As  USHORT ,ByVal max As  USHORT )	
	If this.Handle Then
		b_min		= min
      b_max		= max 
	EndIf
End Sub
'
Function FProgress.ProgressSubClass(hWnd AS HWND,uMsg AS UINT,wParam AS wParam,lParam AS lParam) AS LRESULT 
	
	Function = 0
	Dim As HDC hDC
   Dim As RECT rc,txtrc
   Dim As HBRUSH hBr
   Dim As ZString * 128 szText
	
	Dim as FProgress ptr FProg = cast(FProgress Ptr,GetWindowLong(hWnd,GWL_USERDATA)) ' Zeiger auf diese Klasse
	
	If FProg = 0 Then
		function = DefWindowProc(  hWnd, uMsg, wParam, lParam) 
		Exit Function
	EndIf
	
	Select case uMsg 
		Case WM_ERASEBKGND 
			GetClientRect(hWnd,@rc)
			hBr = CreateSolidBrush(FProg->Color)	
         FillRect(Cast(HANDLE,wParam),@rc,hBr)
         DeleteObject(hBr) 
			Function = TRUE
         Exit Function
         
		Case WM_PAINT
			dim pnt as PAINTSTRUCT	
			GetClientRect(hWnd,@txtrc)
         hDC = BeginPaint( hWnd, @pnt )
        	hBr = CreateSolidBrush(FProg->b_ProgressColor)
			rc.left	=0
   		rc.top 	=0
   		rc.bottom= FProg->Height
   		rc.Right = FProg->b_DrawPos
   		FillRect(hDC,@rc,hBr)
   		DeleteObject(hBr) 
   		If Len(FProg->Caption) > 0 Then
   			szText = FProg->Caption + Chr(0)
   			SetBkMode(hDc, TRANSPARENT)
	         SetTextColor(hDC,FProg->TextColor)
	         DeleteObject(SelectObject(hDc,FProg->Font))        	
   			DrawText(hDC,@szText,-1,@txtrc,DT_CENTER Or DT_SINGLELINE Or DT_VCENTER)
   		EndIf
			EndPaint( hWnd, @pnt )
   		Exit Function	 
   		
   	Case WM_RBUTTONDOWN
   		If FProg->onRbuttondown Then
         	FProg->onRbuttondown(LOWORD(lParam),HIWORD(lParam))
   		End If	
   		Exit Function
   		'------------------------- 			
   	Case WM_LBUTTONDOWN
   		If FProg->onLbuttondown Then
         	FProg->onLbuttondown(LOWORD(lParam),HIWORD(lParam))
   		End If	
   		Exit Function		
   		
		Case WM_DESTROY
			SetWindowLong(hWnd, GWL_WNDPROC, FProg->b_oldProc)
			FProg->b_oldProc = 0
			Exit Function	
	End Select
	
	function = CallWindowProc( Cast(Any Ptr,FProg->b_oldProc), hWnd, uMsg, wParam, lParam) 
End Function

Sub FProgress.Create(ByVal hParent As HWND, ByVal x As Integer,ByVal y As Integer,ByVal w As Integer,ByVal h As Integer )
	
   Dim As ZString * 32 szClass
   Dim As HINSTANCE hInst
   hInst 	= GetModuleHandle(0)
   szClass 	= "msctls_progress32"
         
   this.Handle = CreateWindowEx( this.ExStyle  , @szClass , "", this.Style  , x, y, w , h , _
                           hParent , NULL, hInst , NULL )  
     
                         
                           
   If this.Handle  Then                                                                     
	   this.Parent = hParent
	   this.Left    = x
	   this.Top     = y
	   this.Width   = w
	   this.Height  = h
	   this.Color	 = &HFFFFFF
	   this.b_oldProc = SetWindowLong( this.Handle, GWL_WNDPROC, CInt(@FProgress.ProgressSubClass))
		SetWindowLong(this.Handle ,GWL_USERDATA,CINT(@This)) ' Zeiger diese Instanz
		
		ShowWindow(this.Handle,SW_SHOW)
   Else
   	MessageBox(0,"Fehler - Create Progress","Fehler",MB_ICONERROR)
   End If
	
End Sub
