'------------------------------------------------------------------------------------------
' FImage	 wird von Controls die Bilder laden verwendet
'------------------------------------------------------------------------------------------
Type FImage Extends Object  	
  	Public:
	Declare Property ImgWidth() As Integer					 
  	Declare Property ImgHeight() As Integer	
  	Declare Property ImgWidth(ByVal value  As Integer	)				 
  	Declare Property ImgHeight(ByVal value  As Integer	)					
   Declare Property DC() As HDC							
   Declare Property bkColor() As UInteger
   Declare Property bkColor( ByVal x As UInteger )   
   Declare Sub LoadImg(s As String)
   Declare Sub LoadRes(s As String)   
   Declare Sub ImgCopy(ByVal ZielDC As HDC, ByVal posx As Integer, ByVal posy As Integer)
   Declare Sub ImgCopyRect(ByVal ZielDC As HDC, tRC As RECT, qRC As RECT, ByVal rop As UInteger)
	Declare Destructor 
	
	Private:
   As Integer 	w 	 	= 0
  	As Integer 	h    	= 0
  	As HDC     	tdc   = 0
  	As UInteger bkC 	= &hffffffff
  
End Type

Property FImage.ImgWidth() As Integer
  Return this.w
End Property

Property FImage.ImgHeight() As Integer
  Return this.h
End Property
Property FImage.ImgWidth(ByVal value  As Integer	)		
	this.w = Value
End Property
Property FImage.ImgHeight(ByVal value  As Integer	)	
	this.h = value
End Property
Property FImage.bkColor() As UInteger
	Return this.bkC
End Property
Property FImage.bkColor( ByVal value As UInteger )	
	this.bkC = value	
End Property

Property FImage.DC() As HDC
  Return this.tdc
End Property
DESTRUCTOR FImage 
	If this.tdc <> 0 Then
  		DeleteDC(this.tdc)
	End If
End Destructor

Sub FImage.LoadImg(s As String)
	
	If isFileExist(s) = FALSE Then
		MessageBox(0,"Image Datei nicht gefunden","Fehler",MB_ICONERROR)
		Exit sub
	EndIf
	
	If this.tdc <> 0 Then
  		DeleteDC(this.tdc)
	End If
	
	Dim As Integer w,h
	Dim As UInteger mColor
	Dim As HDC mDC,tmpDC
	Dim As HBITMAP hBmp
	
	mColor = this.bkColor
	
	If ImgLoadFromFile(s, mColor, mDC , w, h ) = 0 Then
		MessageBox(0,"Bild nicht geladen","Fehler", MB_ICONERROR) 
		Exit Sub
	EndIf
		
	this.ImgWidth = w 
	this.ImgHeight = h 
	
	tmpDC = GetDC(GetDesktopWindow)
   this.tdc = CreateCompatibleDC(tmpDC)
   hBmp = CreateCompatibleBitmap(tmpDC,w,h)
	SelectObject(this.tdc,hBmp)
	
	ReleaseDC(GetDesktopWindow,tmpDc)
	DeleteObject(hBmp)
	
	BitBlt(this.tdc,0,0,w,h,mDC,0,0,SRCCOPY)
	
	DeleteDC(mDc)
	mDC = 0 : tmpDc = 0
	
End Sub
'---------------------- alle mit RCDATA Attrib. ---------------------
Sub FImage.LoadRes(resName As String)
	
	If this.tdc <> 0 Then
  		DeleteDC(this.tdc)
	End If
	
	Dim As Integer w,h
	Dim As UInteger mColor
	Dim As HDC mDC,tmpDC
	Dim As HBITMAP hBmp
	
	mColor = this.bkColor
	
	If ImgLoadFromRes(resName, mColor, mDC , w, h ) = 0 Then
		MessageBox(0,"Bild nicht geladen","Fehler", MB_ICONERROR) 
		Exit Sub
	EndIf
		
	this.ImgWidth = w 
	this.ImgHeight = h 
	
	tmpDC = GetDC(GetDesktopWindow)
   this.tdc = CreateCompatibleDC(tmpDC)
   hBmp = CreateCompatibleBitmap(tmpDC,w,h)
	SelectObject(this.tdc,hBmp)
	
	ReleaseDC(GetDesktopWindow,tmpDc)
	DeleteObject(hBmp)
	
	BitBlt(this.tdc,0,0,w,h,mDC,0,0,SRCCOPY)
	
	DeleteDC(mDc)
	mDC = 0 : tmpDc = 0
	
End Sub

Sub FImage.ImgCopy(ByVal ZielDC As HDC,  ByVal zielX As Integer, ByVal zielY As Integer)
	
	If this.tdc<>0 Then
		BitBlt(ZielDC,zielX,zielY,this.ImgWidth,this.ImgHeight,this.tdc,0,0,SRCCOPY)
	EndIf
	
End Sub
Sub FImage.ImgCopyRect(ByVal ZielDC As HDC, tRC As RECT, qRC As RECT, ByVal rop As UInteger)
	
	Dim As UInteger iRop
	
	If rop = 0 Then
		iRop = SRCCOPY
	Else
		iRop = rop
	EndIf
	
	If this.tdc<>0 Then
		StretchBlt(ZielDC,tRC.left,tRC.top,tRC.right,tRC.bottom ,this.tdc,qRC.left,qRC.top,qRC.right,qRC.bottom ,iRop)
	EndIf
	
End Sub